var gPrefService;

function figaro_init() {
  getBrowser().addEventListener("keypress", figaro_handleKeypress, false);
  getBrowser().addEventListener("click", figaro_handleClick, false);
  gPrefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
}

function handleError(desc, page, line, chr) {
alert(
  'JavaScript error occurred! \n'
 +'The error was handled by '
 +'a customized error handler.\n'
 +'\nError description: \t'+desc
 +'\nPage address:      \t'+page
 +'\nLine number:       \t'+line
 );
 return true;
}

function figaro_parent_path() {
  //window.onerror = handleError;
  /*
  CASES:
  Has hash -> remove hash
     (http://bob.com/things/stuff.cgi?blah#hithere -> http://bob.com/things/stuff.cgi?blah)
  Has query string -> remove query string
     (http://bob.com/things/stuff.cgi?blah -> http://bob.com/things/stuff.cgi)
  Has path, no ending / -> remove to last /
     (http://bob.com/things/stuff.cgi -> http://bob.com/things/)
  Has path, ending / -> remove to second-to-last /
     (http://bob.com/things/ -> http://bob.com/)
  Path is / -> no-op
     (http://bob.com/ -> http://bob.com/)
  */
  var location = window._content.document.location;
  if (location.hash.length > 0) { // this doesn't seem to do anything
    //alert("setting hash to empty");
    location.hash = "";
    return;
  }
  else if (location.search.length > 0) {
    //alert("setting search to empty");
    location.search = "";
    return;
  }
  else if (location.pathname.length == 1) {
    //alert("doing nothing");
    // do nothing
    return;
  }
  else {
    //alert("handling more usual case");
    var pathname = location.pathname;
    //alert("pathname is " + pathname);
    //alert(pathname.lastIndexOf("/"));
    if (pathname.lastIndexOf("/") == pathname.length - 1) {
      //alert("removing last /");
      pathname = pathname.substring(0, pathname.length - 1); // /blah/ -> /blah
    }
    pathname = pathname.substring(0, pathname.lastIndexOf("/") + 1);
    //alert("setting pathname to " + pathname);
    location.pathname = pathname;
  }

  return true;
}

function figaro_root_path() {
  //alert("calling method");
  window._content.document.location.pathname = "/";
  //window._content.document.location.search = "";
  //window._content.document.location.hash = "";
}

var figaro_enableOneCharShortcuts = true;

function figaro_handleBackspace() {
  if (figaro_enableOneCharShortcuts) {
    BrowserBack();
  }

  return true;
}

function figaro_handleForward() {
  if (figaro_enableOneCharShortcuts) {
    BrowserForward();
  }

  return true;
}

// To quote browser.js comments, "focus with the autocomplete widget is all
// hacky and broken," so I have to hijack the starting and stopping of the
// autocomplete stuff.
var figaro_timer;
var figaro_timer_callback = {
    notify: function(aTimer) {
      figaro_enableOneCharShortcuts = true;
    }
};
function figaro_handleKeypress(someEvent) {
  //alert(someEvent.charCode);
  var timeout = gPrefService.getIntPref("accessibility.typeaheadfind.timeout");
  if (!timeout) {
    timeout = 5000;
  }

  if ((someEvent.keyCode == KeyEvent.DOM_VK_SLASH || someEvent.charCode == 39) && figaro_enableOneCharShortcuts) {
    //alert("disabling shortcuts");
    figaro_enableOneCharShortcuts = false;
    figaro_timer = Components.classes['@mozilla.org/timer;1'].createInstance(Components.interfaces.nsITimer);
    figaro_timer.initWithCallback(figaro_timer_callback, timeout, figaro_timer.TYPE_ONE_SHOT);
  }
  else if (someEvent.keyCode == KeyEvent.DOM_VK_ESCAPE && !figaro_enableOneCharShortcuts) {
    //alert("enabling shortcuts");
    figaro_enableOneCharShortcuts = true;
    figaro_timer.cancel();
  }
  else if (!figaro_enableOneCharShortcuts) {
    // reset the timer
    figaro_timer.cancel();
    figaro_timer.initWithCallback(figaro_timer_callback, timeout, figaro_timer.TYPE_ONE_SHOT);
  }

  return false;  // we're just getting information, not handling the event
}

function figaro_handleClick(someEvent) {
  // We won't get clicks unless they're clicking off of the find dialog
  figaro_enableOneCharShortcuts = true;
  figaro_timer.cancel();

  return false;
}

function figaro_onFindBarFocus() {
   figaro_enableOneCharShortcuts = false;
}

function figaro_onFindBarBlur() {
   figaro_enableOneCharShortcuts = true;
}
